//	wt]xH쎺	http://jsdiy.webcrow.jp
//	2018/07

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	L7	L6	L5	L4	L3	L2	L1	L0		LEDio[LEDx2ACe`LEDx8AŃspj
portC	x	*	SCL	SDA	sw	-	L9	L8		I2CAXCb`ALEDij
portD	-	-	-	-	-	Zc	Yc	Xc		X,Y,ZLED̃R

yATmega328Pz
|543210---54321|
|CCCCCCGRVBBBBB|
>              |
|CDDDDDVGBBDDDB|
|601234--675670|
*/
/*
yX-Y:o[LEDz
[0]	80<=a
[1]	60<=a<80
[2]	40<=a<60
[3]	20<=a<40
[4]	-5<=a<20	}-5<=a<=5̂Ƃ[4][5]Ƃ_
[5]	-20<a<=5	}
[6]	-40<a<=-20
[7]	-60<a<=-40
[8]	-80<a<=-60
[9]	....a<=-80

yZ:~zuLEDz
אڂ2LEDɓ_pxi8ʂ̍E30x͈̔́j
F[0]`[1]Ԃ45x3(45/3=15)A^񒆂15x͈̔͂[0],[1]Ƃ_B
@@][0]`[7]ꂼꍶE30x͈̔͂_B
   [0]		[0]	0-30<=a<0+30		[4]	180-30<=a<180+30
 [7] [1]	[1]	45-30<=a<45+30		[5]	225-30<=a<225+30
[6]   [2]	[2]	90-30<=a<90+30		[6]	270-30<=a<270+30
 [5] [3]	[3]	135-30<=a<135+30	[7]	315-30<=a<315+30
   [4]
*/

#include <avr/io.h>
#include "mpu6050lib.h"
#include "ledctrl.h "

//LEDԍ16rbgϐ̃rbgʒȗΉ
typedef	enum
{
	ELed0	= (1<<0),
	ELed1	= (1<<1),
	ELed2	= (1<<2),
	ELed3	= (1<<3),
	ELed4	= (1<<4),
	ELed5	= (1<<5),
	ELed6	= (1<<6),
	ELed7	= (1<<7),
	ELed8	= (1<<8),
	ELed9	= (1<<9)
}
ELedIndex;

//LED̃Rs
typedef	enum
{
	ECommonX = (1<<PORTD0),
	ECommonY = (1<<PORTD1),
	ECommonZ = (1<<PORTD2)
}
ECommonPin;

//vg^Cv錾
static	void	LedOff(void);
static	void	LedOn(ECommonPin commonPin, uint16_t ledBits);
static	uint16_t	GetBarLedBit(int16_t angle);
static	uint16_t	GetDirLedBit(int16_t angle);

//LED
static	void	LedOff(void)
{
	//XLEDLoo͂
	PORTB = 0x00;
	PORTC &= 0xFC;
	
	//RHio͂
	PORTD |= ECommonX | ECommonY | ECommonZ;
}

//LED_
static	void	LedOn(ECommonPin commonPin, uint16_t ledBits)
{
	//XLEDHio͂
	PORTB = (uint8_t)(ledBits & 0xFF);
	PORTC |= (uint8_t)((ledBits >> 8) & 0x03);
	
	//RLoo͂
	PORTD &= ~commonPin;
}

//ʏ퓮쒆̗lq\
void	LED_DisplayOperation(TFAxis* fangle, ETargetLed targetLed)
{
	ECommonPin	commonPin;
	uint16_t	ledBits = 0x0000;
	
	switch (targetLed)
	{
	case ETargetLedX:
		commonPin = ECommonX;
		ledBits = GetBarLedBit((int16_t)fangle->x);
		break;
		
	case ETargetLedY:
		commonPin = ECommonY;
		ledBits = GetBarLedBit((int16_t)fangle->y);
		break;
		
	case ETargetLedZ:
	default:
		commonPin = ECommonZ;
		ledBits = GetDirLedBit((int16_t)(-fangle->z));	//LEDzuɍ킹邽ߊpxtɂ
		break;
	}
	
	LedOff();
	LedOn(commonPin, ledBits);
}

//␳̗lq\
void	LED_DisplayAdjust(void)
{
	//X-Y:o[LED	->[i[0][9]j_
	//Z:~zuLED	->_Ȃ
	
	ECommonPin	commonPin = ECommonX | ECommonY;
	uint16_t	ledBits = ELed0 | ELed9;

	LedOff();
	LedOn(commonPin, ledBits);
}

//pxɉLED_ʒu擾io[LEDj
static	uint16_t	GetBarLedBit(int16_t angle)
{
	uint16_t ledBits = 0x0000;
	
	if (80 <= angle) { ledBits |= ELed0; }
	if (60 <= angle && angle < 80) { ledBits |= ELed1; }
	if (40 <= angle && angle < 60) { ledBits |= ELed2; }
	if (20 <= angle && angle < 40) { ledBits |= ELed3; }
	if (-5 <= angle && angle < 20) { ledBits |= ELed4; }
	if (-20 < angle && angle <= 5) { ledBits |= ELed5; }
	if (-40 < angle && angle <= -20) { ledBits |= ELed6; }
	if (-60 < angle && angle <= -40) { ledBits |= ELed7; }
	if (-80 < angle && angle <= -60) { ledBits |= ELed8; }
	if (angle <= -80) { ledBits |= ELed9; }

	return ledBits;
}

//pxɉLED_ʒu擾i~zuLEDj
static	uint16_t	GetDirLedBit(int16_t angle)
{
	uint16_t ledBits = 0x0000;
	const	int16_t	STEP = 45;		//LED45x݂ŔzuĂ
	const	int16_t	RANGE = 30;		//1LED+-30x͈̔͂œ_
	
	while (angle < 0) { angle += 360; }		//̏]ZȂ悤ɂ
	angle %= 360;
	
	if (angle < STEP * 0 + RANGE) { ledBits |= ELed0; }
	if (STEP * 1 - RANGE <= angle && angle < STEP * 1 + RANGE) { ledBits |= ELed1; }
	if (STEP * 2 - RANGE <= angle && angle < STEP * 2 + RANGE) { ledBits |= ELed2; }
	if (STEP * 3 - RANGE <= angle && angle < STEP * 3 + RANGE) { ledBits |= ELed3; }
	if (STEP * 4 - RANGE <= angle && angle < STEP * 4 + RANGE) { ledBits |= ELed4; }
	if (STEP * 5 - RANGE <= angle && angle < STEP * 5 + RANGE) { ledBits |= ELed5; }
	if (STEP * 6 - RANGE <= angle && angle < STEP * 6 + RANGE) { ledBits |= ELed6; }
	if (STEP * 7 - RANGE <= angle && angle < STEP * 7 + RANGE) { ledBits |= ELed7; }
	if (STEP * 8 - RANGE <= angle) { ledBits |= ELed0; }
	
	return ledBits;
}
