//	3x/WC MPU-6050̎
//	wt]xH쎺	http://jsdiy.webcrow.jp

/*
y|[gΉz	ATmega328P	x:݂Ȃ(PC6RESET) -:
bit		7	6	5	4	3	2	1	0
portB	L7	L6	L5	L4	L3	L2	L1	L0		LEDio[LEDx2ACe`LEDx8AŃspj
portC	x	*	SCL	SDA	sw	-	L9	L8		I2CAXCb`ALEDij
portD	-	-	-	-	-	Zc	Yc	Xc		ZLED̃RAX,YLED̃R

yATmega328Pz
|543210---54321|
|CCCCCCGRVBBBBB|
>              |
|CDDDDDVGBBDDDB|
|601234--675670|

yq[Yrbgz(ftavrw.exe -rf)	Hoאݒ Low:01100010(62), Hi:11-11001(D9)
Low: 11100010 (E2)
     ||||++++-- CKSEL[3:0] VXeNbNI
     ||++-- SUT[1:0] N
     |+-- CKOUT (0:PB0ɃVXeNbNo)
     +-- CKDIV8 NbNl (1:1/1, 0:1/8)

High:11-11001 (D9)
     |||||||+-- BOOTRST f[^V[gQ
     |||||++-- BOOTSZ[1:0] f[^V[gQ
     ||||+-- EESAVE (EEPROM 1:, 0:ێ)
     |||+-- WDTON (1:WDTʏ퓮, 0:WDT펞ON)
     ||+-- SPIEN (1:ISP֎~, 0:ISP) Parallel̂
     |+-- DWEN (On-ChipfobO 1:, 0:L)
     +-- RSTDISBL (RESETs 1:L, 0:(PC6))

Ext: -----111 (FF)
          +++-- BODLEVEL[2:0] (111:, 110:1.8V, 101:2.7V, 100:4.3V)
*/
/*
yrhz
Atmel Studio 7 (Version: 7.0.1417 - )
ATmega328P  8MHzi8MHz/Ȃj

yXVz
2018/06	v1.00
	ELN^LCDɊpx\BX,Y,Z̃WC␳tB
	Program Memory Usage 	:	4598 bytes   14.0 % Full
	Data Memory Usage 		:	52 bytes   2.5 % Full

2018/07	v2.00
	Ev1.00ɉAX-Y␳tB
	E{^͂ɑΉB
	Empu6050libCB
	Program Memory Usage 	:	7110 bytes   21.7 % Full
	Data Memory Usage 		:	54 bytes   2.6 % Full

2018/07	v3.00
	Ev2.00CEǁB
	ELED\B
	Program Memory Usage 	:	7536 bytes   23.0 % Full
	Data Memory Usage 		:	54 bytes   2.6 % Full

2018/07	v3.10
	EMPU6050_Init()̈ύXB
	Empu6050libCB
	Program Memory Usage 	:	7546 bytes   23.0 % Full
	Data Memory Usage 		:	54 bytes   2.6 % Full
*/

/*	ԑJ
N
y␳[hz
htg␳l擾ij
X,Y␳i蓮j
Z
X,Y␳l𔽉f
ZZbg
u샂[hv

y샂[hz
Z
ZZbg
u샂[hvp

y샂[hz

␳p[^Zbg
u␳[hv
*/

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <util/delay.h>
#include "twilib.h"
#include "twiclcd/I2cCharLcdLib.h"
#include "mpu6050lib.h"
#include "ledctrl.h "

//XCb`̉
typedef	enum
{
	SWSTATE_OFF,		//Itł葱Ă
	SWSTATE_ON,			//IɂȂu
	SWSTATE_SHORTHOLD,	//Ił葱Ăԁiw莞Ԗj
	SWSTATE_LONGHOLD,	//Ił葱Ăԁiw莞Ԉȏo߁j
	SWSTATE_RELEASE		//ItɂȂu
}
ESwitchState;

//XCb`̃|[g`
#define SW_PIN	PINC
#define SW_BIT	PINC3

//샂[h
typedef	enum
{
	MODE_ADJUST,
	MODE_OPERATION
}
EMode;

//␳l\
typedef	struct
{
	float	degpsDrift;
	float	angleMax;
	float	angleMin;
	float	angleScalePlus;
	float	angleScaleMinus;
}
TAdjustParam;
//
typedef	struct
{
	TAdjustParam x;
	TAdjustParam y;
	TAdjustParam z;
}
TAdjust;
	
//vg^Cv錾
static	void	WaitSec(uint8_t sec);
static	ESwitchState	GetSwitchState(void);
static	void	ResetAdjustParam(TAdjust* adjust, TFAxis* fangle);
static	void	ResetAngleZ(TFAxis* fangle);
static	float	ResetTimerCounter(void);
static	void	AdjustGyro(TAdjust* adjust);
static	void	UpdateAngleRange(TFAxis* angle, TAdjust* adjust);
static	void	SetAngleScale(TAdjust* adjust);
static	void	AdjustSensorValue(TMpu6050Value* sensor, TAdjust* adjust);
static	void	DisplayOperation(TFAxis* fangle, TFAxis* degps);
static	void	DisplayAdjust(TFAxis* fangle);

int main(void)
{
	TMpu6050Value	sensor;
	uint8_t	mode;		//샂[h
	TAdjust	adjust;		//ZT[̕␳l
	float	timeSec;	//ZT[ǂݎ(b)
	TFAxis	fangle;		//px̌vZl
	uint8_t isOK;
	uint8_t	loopCount;
	ETargetLed	targetLed;

	//XCb`Ɩgp̃rbg͓͕EvAbvȂ͏o͕EoLo
	DDRB	= 0xFF;
	PORTB	= 0x00;
	DDRC	= (1<<PORTC5) | (1<<PORTC4) | (1<<PORTC1) | (1<<PORTC0);
	PORTC	= (1<<PORTC3) | (1<<PORTC2);
	DDRD	= (1<<PORTD2) | (1<<PORTD1) | (1<<PORTD0);
	PORTD	= (1<<PORTD7) | (1<<PORTD6) | (1<<PORTD5) | (1<<PORTD4) | (1<<PORTD3);
	
	//d͍팸
	PRR		=	(0<<PRTWI) | (1<<PRTIM2) | (0<<PRTIM0) | (1<<PRTIM1) | (1<<PRSPI) | (1<<PRUSART0) | (1<<PRADC);
	ACSR	=	(1<<ACD);
	
	//8bit^C}[Zbg
	//TCCR0B:WGM02; TCCR0A:WGM01,WGM00 = 000:W
	//TCCR0B:CS02,CS01,CS00 = 001:Ȃ, 010:8, 011:64, 100:256, 101:1024
	TCCR0A	= 0x00;
	TCCR0B	= (0b101 << CS00);
	
	//Ӌ@̋N҂
	WaitSec(1);
	
	//I2C,LCD
	TWI_MasterInit();
	I2CLCD_Init(I2CLCD_DEFAULT_SLA, 16, 2);
	I2CLCD_SetLineMode(LCD_LINEMODE_COMBINE | LCD_LINEMODE_OVERWRITE, LCD_CURSOR_ON);
	
	//ZT[
	//isOK = MPU6050_Init();
	isOK = MPU6050_Init2(MPU6050_GYRO_SCALE_500deg, MPU6050_ACCEL_SCALE_DEFAULT);
	if (!isOK) { I2CLCD_PutStringP(PSTR("MPU6050 NG"));	goto FINISH; }
	
RESTART:
	while (GetSwitchState() != SWSTATE_OFF) { _delay_ms(100); }	//{^ĂȂԂɂȂ܂ő҂
	
	mode = MODE_ADJUST;
	ResetAdjustParam(&adjust, &fangle);
	
	//WC̃htg̕␳l߂
	I2CLCD_Clear();
	I2CLCD_SetPos(0, 0);	I2CLCD_PutStringP(PSTR("Gyro Adjust..."));
	AdjustGyro(&adjust);
	
	//XY␳AсAʏ퓮Jn
	I2CLCD_SetPos(1, 0);	I2CLCD_PutStringP(PSTR("X-Y Angle Adj..."));
	
	loopCount = 0;
	targetLed = ETargetLedX;
	ResetTimerCounter();
	
	while (1)
    {
		//ZT[ǂݎ
	    MPU6050_GetValue(&sensor);
		timeSec = ResetTimerCounter();
		
		//x̍őlEŏlXVi␳Ŏgpj
		UpdateAngleRange(&sensor.angle, &adjust);
		
		//px
		AdjustSensorValue(&sensor, &adjust);
		fangle.x = (fangle.x + sensor.degps.x * timeSec) * 0.8 + sensor.angle.x * 0.2;
		fangle.y = (fangle.y + sensor.degps.y * timeSec) * 0.8 + sensor.angle.y * 0.2;
		fangle.z =  fangle.z + sensor.degps.z * timeSec;
		
		//\XV(LED)
		//if (loopCount % 2 == 0)
		{
			if (mode == MODE_OPERATION)
			{
				targetLed = (targetLed + 1) % ENumOfTarget;
				LED_DisplayOperation(&fangle, targetLed);
			}
			else if (mode == MODE_ADJUST)
			{
				LED_DisplayAdjust();
			}
		}
		
		//\XV(LCD)
		if (loopCount % 64 == 0)
		{
			if (mode == MODE_OPERATION)
			{
				DisplayOperation(&fangle, &sensor.degps);
			}
			else if (mode == MODE_ADJUST)
			{
				DisplayAdjust(&fangle);
			}
		}
		
		//XCb`ǂݎ
		if (loopCount % 8 == 0)
		{
			ESwitchState swst = GetSwitchState();
			if (swst == SWSTATE_LONGHOLD)
			{
				goto RESTART;
			}
			else if (swst == SWSTATE_RELEASE)
			{
				if (mode == MODE_ADJUST)
				{
					SetAngleScale(&adjust);		//x̕␳l肷
					mode = MODE_OPERATION;
				}
				else if (mode == MODE_OPERATION)
				{
					ResetAngleZ(&fangle);	//xZT[Z̒lZbg
				}
			}
		}
		
		loopCount++;
    }

FINISH:	
	return 0;
}

//ԑ҂
static	void	WaitSec(uint8_t sec)
{
	for (uint8_t i = 0; i < sec * 10; i++) { _delay_ms(100); }
}

//{^̉Ԃ𔻒肷
//E̊ԊuŌĂяoĒÕ{^ԂƔr邱ƂŌ݂̏Ԃ𔻒肷B
static	ESwitchState	GetSwitchState(void)
{
	static	uint8_t	prevPin = 0x00;		//XCb`EItԂ\
	static	uint8_t holdCount = 0;
	const	uint8_t MaxHoldCount = 100;	//JEgAbv璷Ɣ肷邩
	uint8_t	nowSwState;
	
	uint8_t	nowPin = ~SW_PIN & (1 << SW_BIT);	//XCb`EÎƂ'0'AIt̂Ƃ'0'

	if (prevPin == 0 && nowPin != 0)
	{
		nowSwState = SWSTATE_ON;
	}
	else if (prevPin != 0 && nowPin != 0)
	{
		if (holdCount == MaxHoldCount)
		{
			I2CLCD_SetPos(0, 0);	I2CLCD_PutStringP(PSTR("RESTART"));
			nowSwState = SWSTATE_LONGHOLD;
		}
		else
		{
			holdCount++;
			nowSwState = SWSTATE_SHORTHOLD;
		}
	}
	else if (prevPin != 0 && nowPin == 0)
	{
		nowSwState = SWSTATE_RELEASE;
	}
	else
	{
		holdCount = 0;
		nowSwState = SWSTATE_OFF;
	}

	prevPin = nowPin;
	
	return nowSwState;
}

//␳֌W̕ϐ
static	void	ResetAdjustParam(TAdjust* adjust, TFAxis* fangle)
{
	adjust->x.angleMax = adjust->y.angleMax = adjust->z.angleMax = 0.0;
	adjust->x.angleMin = adjust->y.angleMin = adjust->z.angleMin = 0.0;
	
	adjust->x.angleScalePlus = adjust->y.angleScalePlus = adjust->z.angleScalePlus = 1.0;
	adjust->x.angleScaleMinus = adjust->y.angleScaleMinus = adjust->z.angleScaleMinus = 1.0;
	
	adjust->x.degpsDrift = adjust->y.degpsDrift = adjust->z.degpsDrift = 0.0;
	
	fangle->x = fangle->y = fangle->z = 0.0;
}

//xZT[Z̒lZbg
static	void	ResetAngleZ(TFAxis* fangle)
{
	fangle->z = 0.0;
}

//^C}[JE^[Zbg
//߂lF	O񃊃Zbǧoߎ(sec)
//E^C}[JE^[̓VXeNbN1024œ삵Ă̂ƂB
static	float	ResetTimerCounter(void)
{
	uint8_t	tcnt = TCNT0;
	float	timeSec = (float)tcnt / ((float)F_CPU / 1024);	//1024
	TCNT0 = 0x00;			//^C}[JE^[Zbg
	TIFR0 = (1 << TOV0);	//TOV0rbg'1'ނƂŃI[o[t[tOZbg
	return timeSec;
}

//WCZT[̃htg̕␳l߂
static	void	AdjustGyro(TAdjust* adjust)
{
	TMpu6050Value	sensor;
	float	dx = 0.0, dy = 0.0, dz = 0.0;
	const	uint8_t	LOOP = 4;

	for (uint8_t i = 0; i < LOOP; i++)
	{
		_delay_us(10);
		MPU6050_GetValue(&sensor);
		dx += sensor.degps.x;
		dy += sensor.degps.y;
		dz += sensor.degps.z;
	}
	
	adjust->x.degpsDrift = dx / LOOP;
	adjust->y.degpsDrift = dy / LOOP;
	adjust->z.degpsDrift = dz / LOOP;
}

//x̍őEŏlXV
static	void	UpdateAngleRange(TFAxis* angle, TAdjust* adjust)
{
	if (adjust->x.angleMax < angle->x) { adjust->x.angleMax = angle->x; }
	if (adjust->x.angleMin > angle->x) { adjust->x.angleMin = angle->x; }
	
	if (adjust->y.angleMax < angle->y) { adjust->y.angleMax = angle->y; }
	if (adjust->y.angleMin > angle->y) { adjust->y.angleMin = angle->y; }
	
	if (adjust->z.angleMax < angle->z) { adjust->z.angleMax = angle->z; }
	if (adjust->z.angleMin > angle->z) { adjust->z.angleMin = angle->z; }
}

//x̕␳l肷
//Ex̌X𓾂ŕ␳B␳sׂɌvZƃ[ZƂȂ邽߁B
static	void	SetAngleScale(TAdjust* adjust)
{
	const	float	THRESHOLD = 60.0;
	
	if (THRESHOLD < adjust->x.angleMax) { adjust->x.angleScalePlus = 90.0 / adjust->x.angleMax; }
	if (-THRESHOLD > adjust->x.angleMin) { adjust->x.angleScaleMinus = -90.0 / adjust->x.angleMin; }

	if (THRESHOLD < adjust->y.angleMax) { adjust->y.angleScalePlus = 90.0 / adjust->y.angleMax; }
	if (-THRESHOLD > adjust->y.angleMin) { adjust->y.angleScaleMinus = -90.0 / adjust->y.angleMin; }

	if (THRESHOLD < adjust->z.angleMax) { adjust->z.angleScalePlus = 90.0 / adjust->z.angleMax; }
	if (-THRESHOLD > adjust->z.angleMin) { adjust->z.angleScaleMinus = -90.0 / adjust->z.angleMin; }
}

//擾ZT[l␳
static	void	AdjustSensorValue(TMpu6050Value* sensor, TAdjust* adjust)
{
	sensor->degps.x -= adjust->x.degpsDrift;
	sensor->degps.y -= adjust->y.degpsDrift;
	sensor->degps.z -= adjust->z.degpsDrift;
	
	sensor->angle.x *= (0.0 <= sensor->angle.x ? adjust->x.angleScalePlus : adjust->x.angleScaleMinus);
	sensor->angle.y *= (0.0 <= sensor->angle.y ? adjust->y.angleScalePlus : adjust->y.angleScaleMinus);
	sensor->angle.z *= (0.0 <= sensor->angle.z ? adjust->z.angleScalePlus : adjust->z.angleScaleMinus);
}

//ʏ퓮쒆̗lq\
static	void	DisplayOperation(TFAxis* fangle, TFAxis* degps)
{
	I2CLCD_Clear();
	I2CLCD_SetPos(0, 0);	I2CLCD_PutString("Ang ");
	I2CLCD_PutInt(fangle->x);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(fangle->y);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(fangle->z);
				
	I2CLCD_SetPos(1, 0);	I2CLCD_PutString("D/s ");
	I2CLCD_PutInt(degps->x);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(degps->y);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(degps->z);
}

//␳̗lq\
static	void	DisplayAdjust(TFAxis* fangle)
{
	I2CLCD_SetPos(0, 0);	I2CLCD_PutStringP(PSTR("Ang             "));
	I2CLCD_SetPos(0, 4);
	I2CLCD_PutInt(fangle->x);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(fangle->y);	I2CLCD_PutChar(' ');
	I2CLCD_PutInt(fangle->z);
}
