//	キャラクタLCD I2C化アダプタ：マスター／スレーブ間で参照する共通の定数定義
//	『昼夜逆転』工作室	http://jsdiy.webcrow.jp
//	2017/06	初版
//	2017/09	'LCD_FUNC_PUTWORD'を追加

/*	【I2Cマスター／スレーブ間の通信内容】
1.	[S][SLA+W](A)[コントロールバイト](A)[データバイト](A)[P]
2.	[S][SLA+W](A)[拡張コントロールバイト](A)[データバイト1](A)<[データバイト2](A)>[P]
3.	[S][SLA+W](A)[拡張コントロールバイト](A)[データバイト1](A)<[データバイト2](A)>
					…
				 [拡張コントロールバイト](A)[データバイト1](A)<[データバイト2](A)>[P]
*/

#ifndef	I2CCHARLCD_H_
#define	I2CCHARLCD_H_


//コントロールバイト
#define	RS_CMD	0x00	//続くデータバイトは「Instruction＋パラメータ」で表される値	（HD44780_Instruction.h 参照）
#define	RS_DATA	0x80	//続くデータバイトは任意の値

//拡張コントロールバイト（実行命令のラベル）
//・具体値として'0'(RS_CMD)と'128'(RS_DATA)を定義してはいけない。
enum ELcdFunc
{							//続くデータバイトの長さと内容
	LCD_FUNC_INIT = 1,		//2byte:	LCDの桁数,行数
	LCD_FUNC_SETLINEMODE,	//2byte:	行の動作。例(LCD_LINEMODE_AAA | LCD_LINEMODE_BBB, LCD_CURSOR_ON)
	LCD_FUNC_SETPOS_XY,		//2byte:	表示位置。桁(x:column),行(y:row)の順に2byte
	LCD_FUNC_PUTCHAR,		//1byte:	文字コード
	LCD_FUNC_PUTINT,		//2byte:	符号あり整数。10進表示。8bit/16bit整数ともHi-Loの順に2byte
	LCD_FUNC_PUTUINT,		//2byte:	符号なし整数。10進表示。8bit/16bit整数ともHi-Loの順に2byte
	LCD_FUNC_PUTBYTE,		//1byte:	16進表示
	LCD_FUNC_PUTWORD		//2byte:	16進表示。Hi-Loの順に2byte
};


#endif	//I2CCHARLCD_H_
